;
; ===========================================================================
;                Patch script for NetMgr v1.00 (DOS Version)
;           Version 3.00 with alternative vectors - 01. Jan 2000
;
;    Created by Tobias Ernst, Fido 2:2476/418, e-mail tobi@bland.fido.de
; ===========================================================================
;
; NOTE: This patch script will rename netmgr.exe into netmgr.ovl if the patch
;       is successful. You will have to execute netmgr by using netmgr.com
;       which should have been supplied to you together with this patch file.
;
;       If you wish to understand this patch, you will want to see what
;       the service routines on interrupts 4B..4E do. Have a
;       look at netmgr.asm for this. It is the source for netmgr.com.
;
SIZE 180214                ; filesize netmgr.exe
;
COPY UNPATCH\NETMGR.EXE    ; make a backup copy in <NetmgrPath>\unpatch
;
REN NETMGR.OVL             ; rename pached netmgr.exe to netmgr.ovl in order
                           ; to prevent the patched executable from being
                           ; executed without installed interrupt handlers
;
; ---------------------------------------------------------------------------
;
;
; Fix for writing *.MSG FTSC date field
VER 238E3    FF770A   ; push word ptr [bx+0a]
;
CHA $        CD4D+    ; int 4D                   ; push modulo 100
             90       ; nop
;
; Fix for writing Squish date field
VER 21242    FF770A   ; push word ptr [bx+0a]
CHA $        CD4D+    ; int 4D                   ; push modulo 100
             90       ; nop
;
; Fix for writing Hudson date field
VER 1CFF9    FF770A   ; push word ptr [bx+0a]
CHA $        CD4D+    ; int 4D                   ; push modulo 100
             90       ; nop
;
; Fix for writing PKT FTSC date field
VER D8D5     FF740A   ; push word ptr [si+0a]
CHA $        CD4C+    ; int 4C                   ; push modulo 100
             90       ; nop
;
; Fix for reading and interpreting Hudson date field
VER 1C94C    8B46F0   ; mov ax,word ptr [bp-10]  ; get hudson 2 digit year
CHA $        CD4B+    ; int 4B                   ; service 4, get hudson 2 digit
             90       ; nop                      ; year and converto to tm_year
;
; Fix for the header text in bounced messages (and probably other places)
VER 752E     FF740A   ; push word ptr [si+0a]
CHA $        CD4C+    ; int 4C                   ; push modulo 100
             90       ; nop
;
; Fix for %year templates
VER 7D4F     FF770A   ; push word ptr [bx+0a]
CHA $        CD4E+    ; int 4E                   ; push +1900
             90       ; nop
VER 2859E    313925322E326900  ; db "19%2.2i",0
CHA $        25342E3469000000  ; db "%4.4i",0,0,0
;
; Fix for "2028" bug when Opus date fields are not set
VER 27081    2D5000   ; sub ax, 0050
CHA $        CD4F+    ; int 4F
             90       ; nop
;
;Change version numbers from 1.00 to 1.0y
VER 272F2    30
CHA $        79
VER 27725    30
CHA $        79
VER 27756    30
CHA $        79
VER 27772    30
CHA $        79
VER 27844    30
CHA $        79
VER 278D6    30
CHA $        79
VER 29A3D    30
CHA $        79
VER 29ED0    30
CHA $        79
